// A. Sheaff 02/24/05

// Program to test Image and XDisplayImage classes.

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include "image.hh"

// Initialize the display
XDisplayImage Image::xdi(640,480,"Title");

int main(int argc, char * argv[])
{
	// Test constructors and assignment
	Image im("1.gray",640,480);	// Read from file constructor
	Image in=im;	// Copy constructor
	Image imt=im; 
	Image ima(640,480,0x80);	// Constructor for solid color

	// Test title, display, and "pause" function	
	im.title("Image from file");	// Change window title
	im.display();	// Display image
	im.pause();		// Wait for a key

	// Test threshold
	im.title("Threshold");	// Change window title
	im.threshold(120,200);	// Threshold - pixels in range white, else black
	im.display();
	im.pause();

	// Verify colid color constructor
	ima.title("Solid color");	// Change window title
	ima.display();
	ima.pause();

	// Test drawing routines
	in.display();	// Display orginal
	in.setcolor(0x00ff00ff);	// Set pen color
	in.drawline(1,1,200,200);	// Draw a line
	in.setcolor(0x00ffffff);
	in.drawtext(200,200,"Hello World");	// Draw text
	in.setlinewidth(3);	// Make line wider
	in.drawline(30,1,200,200);	
	in.title("Draw on image");	// Change window title
	in.refresh();	// Update the display with drawing extras
	in.pause();

	// Test not operator
	im=~in;		// Not operator
	im.title("Not operator");
	im.display();
	im.pause();

	// Test add operator
	im=imt;
	im+=0x40;	// Add a constant
	im.title("Add operator");
	im.display();
	im.pause();

	// Test subtract operator
	im=imt;
	im-=0x40;	// subtract a constant
	in.title("Subtract operator");
	im.display();
	im.pause();

	// Test add operator
	im=imt;
	im+=255;	// Add a constant
	im.title("Add operator (saturation)");
	im.display();
	im.pause();

	// Test subtract operator
	im=imt;
	im-=255;	// subtract a constant
	im.title("Subtract operator (saturation)");
	im.display();
	im.pause();

	// Test and operator
	im=imt;
	im&=0x80;	// and a constant
	im.title("And operator");
	im.display();
	im.pause();

	// Test or operator
	im=imt;
	im|=0xf0;	// or a constant
	im.title("Or operator");
	im.display();
	im.pause();

	// Test xor operator
	im=imt;
	im^=0xff;	// xor a constant
	im.title("Xor operator");
	im.display();
	im.pause();

	// Random Snow
	Image ii("/dev/urandom",640,480);
	ii.title("Snow");
	ii.display();
	ii.pause();
	ii.threshold(0,127);
	ii.display();
	ii.pause();

	// Write out the snow
	ii.writeimage("snow.gray");
	return 0;
}
